jQuery(document).ready(function ($) {
    'use strict';
    let bopobb_move = false;
    let bopobb_active_select = '';
    bopobb_sortable();
    bopobb_active_settings();
    bopobb_select2_init();

    $(document).on('click', '.bopobb_shortcode_show', function () {
        let $this = $(this),
            this_copied_text = $this.parent().find('.bopobb_copy_tooltip');
        /*Copy event*/
        $this.select();
        document.execCommand('copy');
        /*Show tooltip and auto hide it */
        this_copied_text.css('visibility', 'visible');
        setTimeout(function () {
            this_copied_text.css('visibility', 'hidden');
        }, 1000);
    });

    $(document).on('click', '.bopobb-pbi .bopobb-pbi-remove-button', function (e) {
        e.stopPropagation();
        let _count = $('#bopobb-settings .bopobb-title-contain #bopobb_count').val();
        if (_count > 2) {
            let cf = confirm(bopobbProductVars.bopobb_notice);
            if (cf == true) {
                let _count = $('.bopobb-pbi-contain .bopobb-pbi').length;
                if (parseInt(_count) === 3) {
                    $('.bopobb-bundle-settings .bopobb-pbi-contain .bopobb-pbi a.bopobb-pbi-remove-button').addClass('bopobb-pbi-hidden');
                }
                $(this).closest('.bopobb-pbi-contain .bopobb-pbi').remove();
                _count -= 1;
                let item_index = 0;
                $('.bopobb-bundle-settings #bopobb_count').val(_count);
                if (_count) {
                    $('.bopobb-pbi-contain .bopobb-pbi').each(function () {
                        bopobb_init_item($(this), item_index);
                        item_index += 1;
                    })
                }
                bopobb_ApplyChange();
            }
        } else {
            alert(bopobbProductVars.bopobb_minimum_notice);
        }
    });

    $(document).on('click', '.bopobb-bundle-settings .bopobb-pbi-add-button', function (e) {
        e.stopPropagation();
        let _count = $('#bopobb-settings .bopobb-pbi-contain .bopobb-pbi').length;
        if (_count < 60) {
            let $items_wrap = $('.bopobb-product-panel .bopobb-pbi-contain .bopobb-pbi');
            if (parseInt(_count) == 2) {
                $('.bopobb-bundle-settings .bopobb-pbi-contain .bopobb-pbi a.bopobb-pbi-remove-button').removeClass('bopobb-pbi-hidden');
            }
            $items_wrap.last().find('select.select2-hidden-accessible').select2('destroy');
            var new_row = $items_wrap.last().clone();
            new_row.addClass('closed').removeClass('open');
            $items_wrap.last().after(new_row);
            bopobb_init_item(new_row, -1);
            bopobb_select2_init();
            bopobb_ApplyChange();
        } else {
            alert(bopobbProductVars.bopobb_limit_notice);
        }
    });

    $(document).on('click', '.bopobb-pbi-quantity-rank-button', function (e) {
        let rank_wrap = $(this).closest('tbody').find('.bopobb-pbi-quantity-rank');
        if (rank_wrap.hasClass('bopobb-hidden')) {
            rank_wrap.removeClass('bopobb-hidden')
        } else {
            rank_wrap.addClass('bopobb-hidden');
        }
    });

    $(document).on('keyup change', '.bopobb-pbi-quantity-default', function () {
        let qty = parseInt($(this).val()),
            min = parseInt($(this).closest('tbody').find('.bopobb-pbi-quantity-rank .bopobb-pbi-quantity-min').val()),
            max = parseInt($(this).closest('tbody').find('.bopobb-pbi-quantity-rank .bopobb-pbi-quantity-max').val());
        if (qty < min || isNaN(qty)) {
            alert(bopobbProductVars.bopobb_quantity_min_notice.replace('[d]', min));
            $(this).val(min);
            return;
        }
        if (qty > max) {
            alert(bopobbProductVars.bopobb_quantity_max_notice.replace('[d]', max));
            $(this).val(max);
        }
    });

    $(document).on('change keyup', '.bopobb-pbi-quantity-min', function () {
        let $qty = $(this).closest('tbody').find('.bopobb-pbi-quantity-default'),
            min = parseInt($(this).val()),
            max = parseInt($(this).closest('.bopobb-pbi-input').find('.bopobb-pbi-quantity-max').val());
        if (isNaN(min) || min < 1) {
            alert(bopobbProductVars.bopobb_quantity_start_notice);
            $(this).val(1);
            return;
        }
        if (min <= max && min > parseInt($qty.val())) {
            $qty.val(min);
            return;
        }
        if (min > max) {
            alert(bopobbProductVars.bopobb_quantity_max_notice.replace('[d]', max));
            if (max > parseInt($qty.val())) $qty.val(max);
            $(this).val(max);
        }
    });

    $(document).on('change keyup', '.bopobb-pbi-quantity-max', function () {
        let $qty = $(this).closest('tbody').find('.bopobb-pbi-quantity-default'),
            max = parseInt($(this).val()),
            min = parseInt($(this).closest('.bopobb-pbi-input').find('.bopobb-pbi-quantity-min').val());
        if (isNaN(max)) {
            $(this).val('');
            return;
        }
        if (max < 1) {
            alert(bopobbProductVars.bopobb_quantity_start_notice);
            if (min > 1) {
                $(this).val(min);
                $qty.val(min);
            } else {
                $qty.val(1);
                $(this).val(1);
            }
            return;
        }
        if (max >= min && max < parseInt($qty.val())) {
            $qty.val(max);
            return;
        }
        if (max < min) {
            alert(bopobbProductVars.bopobb_quantity_min_notice.replace('[d]', min));
            $(this).val(min);
        }
    });

    $(document).on('change', '#product-type', function () {
        if (typeof bopobb_get_type !== 'undefined') {
            bopobb_init_new_bopo(bopobb_get_type);
        } else {
            bopobb_active_settings();
        }
    });

    function bopobb_init_new_bopo(type = 'bopobb') {
        if (type == 'bopobb') {
            $('#product-type').val('bopobb');

            $('li.general_tab').addClass('show_if_bopobb');
            $('#_downloadable').closest('label').addClass('show_if_bopobb').removeClass('show_if_simple');
            $('#_virtual').closest('label').addClass('show_if_bopobb').removeClass('show_if_simple');

            $('.show_if_external').hide();
            $('.show_if_simple').show();
            $('.show_if_bopobb').show();

            $('.product_data_tabs li').removeClass('active');
            $('.product_data_tabs li.bopobb_tab').addClass('active');

            $('.panel-wrap .panel').hide();
            $('#bopobb-settings').show();

        }
    }

    function bopobb_init_item(item, index) {
        let _count = $('#bopobb-settings .bopobb-pbi-contain .bopobb-pbi').length;
        let _index = index >= 0 ? index : _count - 1;
        let item_number = _index + 1;
        if (index == -1) {
            $('#bopobb-settings .bopobb-bundle-settings').find('#bopobb_count').val(_count);
            item.find('select.bopobb-pbi-select2').val(null);
        }
        item.find('.bopobb-pbi-header .bopobb-pbi-item-title').html('Bundle item ' + item_number);
        item.find('.bopobb-pbi-header .bopobb-pbi-index').attr('id', 'bopobb_index_' + _index).attr('name', 'bopobb_index_' + _index);

        item.find('.bopobb-pbi-data .bopobb-pbi-category.bopobb-pbi-category-search').attr('id', 'bopobb_pbi_category_' + _index).attr('name', 'bopobb_pbi_category_' + _index + '[]');
        item.find('.bopobb-pbi-data .bopobb-pbi-category-exclude.bopobb-pbi-category-search').attr('id', 'bopobb_pbi_category_exclude_' + _index).attr('name', 'bopobb_pbi_category_exclude_' + _index + '[]');
        item.find('.bopobb-pbi-data .bopobb-pbi-tag.bopobb-pbi-tag-search').attr('id', 'bopobb_pbi_tag_' + _index).attr('name', 'bopobb_pbi_tag_' + _index + '[]');
        item.find('.bopobb-pbi-data .bopobb-pbi-tag-exclude.bopobb-pbi-tag-search').attr('id', 'bopobb_pbi_tag_exclude_' + _index).attr('name', 'bopobb_pbi_tag_exclude_' + _index + '[]');
        item.find('.bopobb-pbi-data .bopobb-pbi-title.bopobb-pbi-product-search').attr('id', 'bopobb_pbi_title_' + _index).attr('name', 'bopobb_pbi_title_' + _index + '[]');
        item.find('.bopobb-pbi-data .bopobb-pbi-title-exclude.bopobb-pbi-product-search').attr('id', 'bopobb_pbi_title_exclude_' + _index).attr('name', 'bopobb_pbi_title_exclude_' + _index + '[]');

        item.find('.bopobb-pbi-data .bopobb-pbi-input .bopobb-pbi-sort').attr('id', 'bopobb_bpi_sort_' + _index).attr('name', 'bopobb_bpi_sort_' + _index);
        item.find('.bopobb-pbi-data .bopobb-pbi-input .bopobb-pbi-order').attr('id', 'bopobb_bpi_order_' + _index).attr('name', 'bopobb_bpi_order_' + _index);
        item.find('.bopobb-pbi-data .bopobb-pbi-input .bopobb-pbi-set-default').attr('id', 'bopobb_bpi_set_default_' + _index).attr('name', 'bopobb_bpi_set_default_' + _index);
        item.find('.bopobb-pbi-data .bopobb-bpi-default-product.bopobb-pbi-default-search').attr('id', 'bopobb_bpi_default_product_' + _index).attr('name', 'bopobb_bpi_default_product_' + _index + '[]');
        item.find('.bopobb-pbi-data .bopobb-pbi-input .bopobb-pbi-quantity-default').attr('id', 'bopobb_bpi_quantity_' + _index).attr('name', 'bopobb_bpi_quantity_' + _index);
        item.find('.bopobb-pbi-data .bopobb-pbi-input .bopobb-pbi-quantity-max').attr('id', 'bopobb_bpi_quantity_max_' + _index).attr('name', 'bopobb_bpi_quantity_max_' + _index);
        item.find('.bopobb-pbi-data .bopobb-pbi-input .bopobb-pbi-discount').attr('id', 'bopobb_bpi_discount_' + _index).attr('name', 'bopobb_bpi_discount_' + _index);
        item.find('.bopobb-pbi-data .bopobb-pbi-input .bopobb-pbi-discount-number').attr('id', 'bopobb_bpi_discount_number_' + _index).attr('name', 'bopobb_bpi_discount_number_' + _index);

    }

    function bopobb_active_settings() {
        if ($('#product-type').val() == 'bopobb') {
            $('li.general_tab').addClass('show_if_bopobb');
            $('#_downloadable').closest('label').addClass('show_if_bopobb').removeClass('show_if_simple');
            $('#_virtual').closest('label').addClass('show_if_bopobb').removeClass('show_if_simple');

            $('.show_if_external').hide();
            $('.show_if_simple').show();
            $('.show_if_bopobb').show();

            $('.product_data_tabs li').removeClass('active');
            $('.product_data_tabs li.bopobb_tab').addClass('active');

            $('.panel-wrap .panel').hide();
            $('#bopobb-settings').show();

            let _count = $('#bopobb-settings .bopobb-title-contain #bopobb_count').val();
            if (parseInt(_count) <= 2) {
                $('.bopobb-bundle-settings .bopobb-pbi-contain .bopobb-pbi a.bopobb-pbi-remove-button').addClass('bopobb-pbi-hidden');
            }

        } else {
            $('li.general_tab').removeClass('show_if_bopobb');
            $('#_downloadable').closest('label').removeClass('show_if_bopobb').addClass('show_if_simple');
            $('#_virtual').closest('label').removeClass('show_if_bopobb').addClass('show_if_simple');

            if ($('#product-type').val() != 'grouped') {
                $('.general_tab').show();
            }

            if ($('#product-type').val() == 'simple') {
                $('#_downloadable').closest('label').show();
                $('#_virtual').closest('label').show();
            }
        }
    }

    function bopobb_sortable() {
        $('.bopobb-pbi-contain').sortable({
            items: '.bopobb-pbi',
            placeholder: 'bopobb-pbi-place-holder',
            cursor: 'move',
            connectWith: '.bopobb-pbi-contain',
            axis: 'y',
            handle: '.bopobb-pbi-item-title',
            start: function (event, ui) {
            },
            over: function (event, ui) {
            },
            receive: function (event, ui) {
                bopobb_move = true;
            },
            stop: function (event, ui) {
                bopobb_ApplyChange();
            }
        }).disableSelection();
    }

    function bopobb_ApplyChange() {
        let index = 0;
        $('.bopobb-pbi-contain .bopobb-pbi .bopobb-pbi-index').each(function () {
            $(this).val(index);
            index = index + 1;
        });
        bopobb_move = false;
    }

    function bopobb_ResetDefault() {
        let _index = bopobb_active_select.closest('.bopobb-pbi').querySelector('.bopobb-pbi-index').value;
        $('#bopobb_bpi_default_product_' + _index).val("").trigger("change");
    }

    function bopobb_select2_init() {
        $(".bopobb-pbi-category-search").select2({
            closeOnSelect: false,
            placeholder: "Please enter category title",
            ajax: {
                url: "admin-ajax.php?action=bopobb_search_cat",
                dataType: 'json',
                type: "GET",
                quietMillis: 50,
                delay: 250,
                data: function (params) {
                    return {
                        keyword: params.term
                    };
                },
                processResults: function (data) {
                    return {
                        results: data
                    };
                },
                cache: true
            },
            escapeMarkup: function (markup) {
                return markup;
            },
            minimumInputLength: 1
        }).on('select2:open', function (e) {
            bopobb_active_select = e.currentTarget;
        }).on("select2:selecting", function (e) {
            bopobb_active_select = e.currentTarget;
            bopobb_ResetDefault();
        }).on("select2:unselecting", function (e) {
            bopobb_active_select = e.currentTarget;
            bopobb_ResetDefault();
        });

        $(".bopobb-pbi-tag-search").select2({
            closeOnSelect: false,
            placeholder: "Please enter category title",
            ajax: {
                url: "admin-ajax.php?action=bopobb_search_tag",
                dataType: 'json',
                type: "GET",
                quietMillis: 50,
                delay: 250,
                data: function (params) {
                    return {
                        keyword: params.term
                    };
                },
                processResults: function (data) {
                    return {
                        results: data
                    };
                },
                cache: true
            },
            escapeMarkup: function (markup) {
                return markup;
            },
            minimumInputLength: 1
        }).on('select2:open', function (e) {
            bopobb_active_select = e.currentTarget;
        }).on("select2:selecting", function (e) {
            bopobb_active_select = e.currentTarget;
            bopobb_ResetDefault();
        }).on("select2:unselecting", function (e) {
            bopobb_active_select = e.currentTarget;
            bopobb_ResetDefault();
        });

        $(".bopobb-pbi-product-search").select2({
            closeOnSelect: false,
            placeholder: "Please fill in your product title",
            ajax: {
                url: "admin-ajax.php?action=bopobb_search_product",
                dataType: 'json',
                type: "GET",
                quietMillis: 50,
                delay: 250,
                data: function (params) {
                    return {
                        keyword: params.term
                    };
                },
                processResults: function (data) {
                    return {
                        results: data
                    };
                },
                cache: true
            },
            escapeMarkup: function (markup) {
                return markup;
            },
            minimumInputLength: 1
        }).on('select2:open', function (e) {
            bopobb_active_select = e.currentTarget;
        }).on("select2:selecting", function (e) {
            bopobb_active_select = e.currentTarget;
            bopobb_ResetDefault();
        }).on("select2:unselecting", function (e) {
            bopobb_active_select = e.currentTarget;
            bopobb_ResetDefault();
        });

        $(".bopobb-pbi-default-search").select2({
            closeOnSelect: true,
            placeholder: "Please fill in your product title",
            ajax: {
                url: "admin-ajax.php?action=bopobb_default_product",
                dataType: 'json',
                type: "GET",
                quietMillis: 50,
                delay: 250,
                data: function (params) {
                    return {
                        keyword: params.term,
                        cat: $(this).closest('tbody').find('.bopobb-pbi-category.bopobb-pbi-category-search').val(),
                        ex_cat: $(this).closest('tbody').find('.bopobb-pbi-category-exclude.bopobb-pbi-category-search').val(),
                        tag: $(this).closest('tbody').find('.bopobb-pbi-tag.bopobb-pbi-tag-search').val(),
                        ex_tag: $(this).closest('tbody').find('.bopobb-pbi-tag-exclude.bopobb-pbi-tag-search').val(),
                        prod: $(this).closest('tbody').find('.bopobb-pbi-title.bopobb-pbi-product-search').val(),
                        ex_prod: $(this).closest('tbody').find('.bopobb-pbi-input .bopobb-pbi-title-exclude').val()
                    };
                },
                processResults: function (data) {
                    return {
                        results: data
                    };
                },
                cache: true
            },
            escapeMarkup: function (markup) {
                return markup;
            },
            minimumInputLength: 0,
            allowClear: true
        });

    }


    $(document).on('click touch', '.bopobb-pbi .bopobb-pbi-header', function (e) {
        e.stopPropagation();
        if ($(this).closest('.bopobb-pbi').hasClass('bopobb-closed')) {
            $(this).closest('.bopobb-pbi').addClass('bopobb-open').removeClass('bopobb-closed');
            $(this).closest('.bopobb-pbi').find('.bopobb-pbi-data').slideDown();
            $(this).find('.bopobb-pbi-slide-arrow').removeClass('dashicons-arrow-down-alt2').addClass('dashicons-arrow-up-alt2');
        } else {
            $(this).closest('.bopobb-pbi').removeClass('bopobb-open').addClass('bopobb-closed');
            $(this).closest('.bopobb-pbi').find('.bopobb-pbi-data').slideUp();
            $(this).find('.bopobb-pbi-slide-arrow').addClass('dashicons-arrow-down-alt2').removeClass('dashicons-arrow-up-alt2');
        }
    });

});